#!/usr/bin/bash

adresBinarny=$1

readonly maskaBinarna=255
readonly iloscBitow=8
readonly iloscOktetow=4

function binarnaDoDziesietnej {
    local liczba=$1
    local wynik=0
    local podstawa=2
    for ((i=0; $i<${#liczba}; i++))
    do
        local wykladnik=$((${#liczba} - $i - 1))
        local potega=$(($podstawa ** $wykladnik))
        local cyfra=${liczba:$i:1}
        wynik=$(($wynik + $cyfra * $potega))
    done
    echo $wynik
}

function binarnaDoOktetow {
    local binarna=$1
    local dziesietna=$(binarnaDoDziesietnej $binarna)
    local wynik=""
    for ((i=0; $i<$iloscOktetow; i++))
    do
        local przesuniecie=$(($i * $iloscBitow))
        local maska=$(($maskaBinarna << $przesuniecie))
        local czesciowa=$(($dziesietna & $maska))
        local oktet=$(($czesciowa >> $przesuniecie))
        if (( $i > 0 ))
        then
            wynik="."$wynik
        fi
        wynik=$oktet""$wynik
    done
    echo $wynik
}

dziesietnie=$(binarnaDoDziesietnej $adresBinarny)
oktety=$(binarnaDoOktetow $adresBinarny)
echo "w formie dziesietnej: "$dziesietnie
echo "w formie oktetów: "$oktety
